Unit IDB7R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTII12_p;

procedure IDB7R(P :Integer; N1 :Integer; M :Integer; A :Real; H :Real;
                X :Real; var F :Array of Real; var S :Real;
                var IERR :Integer);

implementation

procedure IDB7R(P :Integer; N1 :Integer; M :Integer; A :Real; H :Real;
                X :Real; var F :Array of Real; var S :Real;
                var IERR :Integer);
var
I,I1,I2,J,J1,J2,J3,J4,K,K2,ML,N,N3,NL :Integer;
RR,S1,TX,V,XM,XN,XX :Real;
B :Array [0..7] of Real;
C :Array [0..3] of Real;
D :Array [0..3] of Real;
R :Array [0..7] of Real;
T :Array [0..7] of Real;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170,_180,_190,_200,_210,_220,_230,_240,_250,_260,_270;
begin
N  := N1 div 2;
XX  := X;
NL  := 0;
ML  := 0;
XM  := A + (M - N - 1)*H;
XN  := A + (N - 1)*H;
if ( N ) < 0
 then goto _10
 else if ( N ) > 0
       then goto _20
       else goto _10;
_10:
IERR  := 3;
goto _260;
_20:
K  := Trunc( (X - A)/H + 1 + 0.1E-10 );
K2  := K;
if ( (X - A)*(A + (M - 1)*H - X) ) < 0
 then goto _30
 else if ( (X - A)*(A + (M - 1)*H - X) ) > 0
       then goto _40
       else goto _40;
_30:
IERR  := 2;
goto _260;
_40:
S1  := S;
if ( K2 - N ) < 0
 then goto _50
 else if ( K2 - N ) > 0
       then goto _60
       else goto _60;
_50:
X  := XN + NL*H;
K  := N;
NL  := NL + 1;
TX  := XN;
goto _80;
_60:
if ( K2 - M + N ) < 0
 then goto _80
 else if ( K2 - M + N ) > 0
       then goto _70
       else goto _80;
_70:
X  := XM - ML*H;
K  := M - N;
ML  := ML + 1;
TX  := XM;
_80:
N3  := N + 1;
B[0] := 1;
if ( P - 1 ) < 0
 then goto _110
 else if ( P - 1 ) > 0
       then goto _90
       else goto _110;
_90:
for I:=2 to P do
 begin
  B[I-1] := B[I-2]*(N1 - I + 1);
_100:
 end;
_110:
for I:=1 to N do
 begin
  T[I-1] := (X - A - (K - N + I - 1)*H)/H;
  if ( N1 - P ) < 0
   then goto _250
   else if ( N1 - P ) > 0
         then goto _130
         else goto _120;
_120:
  T[I-1] := B[P-1];
  goto _140;
_130:
  T[I-1] := (Power(T[I-1],N1 - P))*B[P-1];
 end;
_140:
for I:=N3 to N1 do
 begin
  T[I-1] := (A + (K - N + I - 1)*H - X)/H;
  if ( N1 - P ) < 0
   then goto _250
   else if ( N1 - P ) > 0
         then goto _160
         else goto _150;
_150:
  T[I-1] := B[P-1];
  goto _170;
_160:
  T[I-1] := Power(T[I-1],N1 - P)*B[P-1];
 end;
_170:
D[0] := 1;
D[1] := -N1;
D[2] := (N1 - 1)*N;
D[3] := -56;
C[0] := 1;
C[1] := 4;
C[2] := 66;
C[3] := 2416;
RR  := C[N-1]*Power(H,P - 1);
if ( RR ) < 0
 then goto _180
 else if ( RR ) > 0
       then goto _190
       else goto _180;
_180:
IERR  := 1;
goto _260;
_190:
for I:=1 to N do
 begin
  I1  := N1 - I + 1;
  V  := 0;
  for J:=1 to I do
   begin
    J1  := N - J + 1;
    J2  := I - J + 1;
    V  := V + D[J2-1]*T[J1-1];
_200:
   end;
  R[I1-1] := V/RR;
_210:
 end;
for I:=1 to N do
 begin
  V  := 0;
  for J:=1 to I do
   begin
    J3  := J + N;
    J4  := I - J + 1;
    V  := V + D[J4-1]*T[J3-1];
_220:
   end;
  R[I-1] := Power(-1,P + 1)*V/RR;
_230:
 end;
S  := 0;
for I:=1 to N1 do
 begin
  I2  := K - N + I;
  S  := S + F[I2-1]*R[I-1];
_240:
 end;
C[0] := 1;
C[1] := 2.0/3.0;
C[2] := 11.0/20.0;
C[3] := 151.0/315.0;
S  := C[N-1]*S;
if ( NL  =  0 ) and (  ML  =  0 ) 
 then goto _270;
if ( NL  =  1 ) or (  ML  =  1 ) 
 then goto _40;
if ( NL  =  2 ) 
 then S  := S1 + (S - S1)*(XX - TX)/H;
if ( ML  =  2 ) 
 then S  := S1 + (S1 - S)*(XX - TX)/H;
goto _270;
_250:
IERR  := 4;
goto _260;
_260:
if ( IERR  <>  0 ) 
 then UTII12(IERR,2);
_270:
end;

end.
